
public class MergeSort {
	
	public static void main(String[] args) {
		int [] A = {5,3,7,1,4} ;  //unsorted array
		int n = A.length ; //array length
		
		System.out.print("Initial array : " ) ; 
		printmyarray(A,n) ; 
		System.out.println("  " ) ; 
		
		mergesort(A, 0, n - 1) ; 
		
		System.out.println("  " ) ; 
		System.out.print("The result is : " ) ; 
		printmyarray(A,n) ; 
	}
	
	public static void mergesort (int A[] , int l , int r ) {
		if (l < r) {
            // Find the middle point
            int m = (l + r) / 2;

            // Recursively sort the first half
            mergesort(A, l, m);

            // Recursively sort the second half
            mergesort(A, m + 1, r);

            // Merge the sorted halves
            merge(A, l, m, r);
        }
	}
	
	// Merge function that merges two sorted subarrays of A
    // First subarray is A[l...m]
    // Second subarray is A[m+1...r]
	
	 public static void merge(int[] A, int l, int m, int r) {
	        // Find sizes of two subarrays to be merged
	        int n1 = m - l + 1;
	        int n2 = r - m;

	        // Create temporary arrays to hold the two halves
	        int[] L = new int[n1];
	        int[] R = new int[n2];

	        // Copy data to temporary arrays L[] and R[]
	        for (int i = 0; i < n1; ++i) {
	            L[i] = A[l + i];
	        }
	        for (int j = 0; j < n2; ++j) {
	            R[j] = A[m + 1 + j];
	        }

	        // Merge the temporary arrays back into A[l...r]

	        // Initial indexes of the first and second subarrays
	        int i = 0, j = 0;

	        // Initial index of merged subarray
	        int k = l;
	        while (i < n1 && j < n2) {
	            if (L[i] <= R[j]) {
	                A[k] = L[i];
	                i++;
	            } else {
	                A[k] = R[j];
	                j++;
	            }
	            k++;
	        }

	        // Copy the remaining elements of L[], if any
	        while (i < n1) {
	            A[k] = L[i];
	            i++;
	            k++;
	        }

	        // Copy the remaining elements of R[], if any
	        while (j < n2) {
	            A[k] = R[j];
	            j++;
	            k++;
	        }
	    }
	
	public static void printmyarraywithiteration (int iteration, int A[] , int n) {
		System.out.print("Iteration: " + iteration + "      ");
		
		System.out.print("[ ");
		for(int i = 0 ; i<n ; i++) {
			System.out.print(A[i] + " " );
		}
		
		System.out.println("]");
	}
	
	public static void printmyarray ( int A[] , int n) {
		
		System.out.print("[");
		for(int i = 0 ; i<n ; i++) {
			System.out.print(A[i] + " " );
		}
		
		System.out.println("]");
	}

}